/*
Author: Cristhian Alcntara Cadillo
Version: Domino 5.5.5 (Domino 2) May 2000
e-mail: tungra@hotmail.com
icq-number:   51821309
icq-username: tungra
Compiler: JDK 1.1.7
Proved with Windows 98,95,Millenium Edition
All rights reserved
*/



import java.io.*;
import java.awt.event.*;
import java.awt.*;
import java.net.*;
import java.util.*;


public class Domino4 extends Frame implements MouseListener, WindowListener{

Panel ladoChat;

P dibujo;

ThreadChat chatd; //demonio del chat, "s, como no"

TextArea conjunto;
TextArea individual;

int maxx,maxy;

Button ok,        paso,	 chat; 

boolean  chatready=false;  //indica si ya inici chat.

static Color color;
static boolean pintar;
Lista lista;

String nombre;
	int turno_de;

Nodo pantalla[],disponibles[],resaltado,pivote, izquierdo, derecho;
ObjectOutput out;
ObjectInput in;
Socket sock;

Movida movida;
Inicial inicial,nombres;
 
boolean turnojuego,primeravez,modonormal,conectado,end_of_game,tu_ganaste;


 int  pos[]={105,165,225,285,345,405,465},
      arriba[]={ 57, 111, 165, 219, 273, 327, 381, 435, 489},
      izquierda[]={35,89,143,197,251};


 int  numeropiezas,x1,y1, piezanumero,ganador;

public Domino4(String e){ 
	super (e); 
      numeropiezas=7;   
	setSize(800,500);
	setResizable(false) ;
	addWindowListener(this);
	color = Color.red;
	info();
	var();  //crear instancias de variables, inicializarlas
	dibujarPaneles();
	protocolo(); //conectar con servidor
	
}

public void dibujarPaneles(){
	Panel a = new Panel();
	Panel derecha = new Panel();
	//derecha.setBackground(Color.black);
	ok = new Button("Exit");
	paso = new Button("Saltar turno");
	chat = new Button("Chat");
		
	ladoChat = new Panel();
	//ladoChat.setLayout(new FlowLayout(FlowLayout.CENTER,10,10));
       //ladoChat.setBackground(Color.black);

	dibujo = new P(this);
			
	GridBagLayout gbl = new GridBagLayout();
	a.setLayout(gbl);
	GridBagConstraints gbc = new GridBagConstraints();
	gbc.fill = GridBagConstraints.BOTH;


	gbc.weightx = 1.0;
	gbc.weighty = 1.0;
	gbc.gridx=0;
	gbc.gridy=0;
	gbc.gridwidth=4;
	gbc.gridheight=4;
	gbl.setConstraints(dibujo,gbc);
	a.add(dibujo);

	conjunto = new TextArea( "",10+3,15, TextArea.SCROLLBARS_VERTICAL_ONLY );
	individual = new TextArea( "",2,40+25, TextArea.SCROLLBARS_VERTICAL_ONLY );
	conjunto.setEditable(false);

	derecha.add(ok);	derecha.add(paso);	
	derecha.add(chat);
	derecha.add(individual);	

	derecha.setBackground(Color.black);
	
	conjunto.setBackground(new Color((float).829 ,(float).8599 , (float).8979) );

	gbc.weighty = 0.12;
	gbc.weightx = 0.15;
	gbc.gridx=4;
	gbc.gridy=0;
	gbc.gridwidth=1;
	gbc.gridheight=1;
	Panel pp = new Titulo();
	gbl.setConstraints(pp,gbc);
	a.add(pp);

	gbc.weighty = 1.0;
	gbc.weighty = 1.0;
	gbc.weightx = 0.15;
	gbc.gridx=4;
	gbc.gridy=1;
	gbc.gridwidth=1;
	gbc.gridheight=3;
	gbl.setConstraints(conjunto,gbc);
	a.add(conjunto);

	gbc.weightx = 1.0;
	gbc.weighty = 0.20;
	gbc.gridx=0;
	gbc.gridy=4;
	gbc.gridwidth= GridBagConstraints.REMAINDER;
	gbc.gridheight=1;
	gbl.setConstraints(derecha,gbc);
	a.add(derecha);


	add(a);


	repintar();

	ok.addMouseListener(this);
	chat.addMouseListener(this);
	paso.addMouseListener(this);
	
	dibujo.addMouseListener(this);

	//enableEvents(MouseEvent.MOUSE_CLICKED );


	setVisible(true);	
	repintar();

	maxx=dibujo.getBounds().width;
	maxy=dibujo.getBounds().height;
	
	dibujarFichas();
      chatd = new ThreadChat(this);

}

 public void var(){


      movida = new Movida();
      pivote = new Nodo();
      izquierdo = new Nodo();
      derecho = new Nodo();
      inicial = new Inicial(); 
      nombres = new Inicial(); 
	lista = new Lista();

      pantalla = new Nodo[28];
      for(int x=0; x<28; x++) pantalla[x]= new Nodo();

      disponibles = new Nodo[7];
      for(int x=0; x<7; x++) disponibles[x] = new Nodo();

      int numero =1;
      int cont;
      for(int x=0; x<9; x++){
          pantalla[x].xo=arriba[x];
          pantalla[x].yo=35;
          pantalla[x].xf=arriba[x]+54;
          pantalla[x].yf=35+30; 
          pantalla[x].colocacion=3;
          pantalla[x].defaultImage(3);
          pantalla[x].setNumero(numero);
          lista.addLast(pantalla[x]);
          numero++;
      }  
      cont=0;

      for(int x=9; x<14; x++){
          pantalla[x].xo=543;
          pantalla[x].yo=izquierda[cont];
          pantalla[x].xf=543+30;
          pantalla[x].yf=izquierda[cont]+54; 
          pantalla[x].colocacion=2;
          pantalla[x].defaultImage(1);
          pantalla[x].setNumero(numero);
          lista.addLast(pantalla[x]);
          cont++;
          numero++;
      }

      for( int x=22; x>=14; x=x-1){
          pantalla[x].xo=arriba[x-14];
          pantalla[x].yo=275;
          pantalla[x].xf=arriba[x-14]+54;
          pantalla[x].yf=275+30;
          pantalla[x].colocacion=4;
          pantalla[x].defaultImage(3);
          pantalla[x].setNumero(numero);
          lista.addLast(pantalla[x]);
          numero++;
      }

      for(int x=27; x>=23; x=x-1){
          pantalla[x].xo=27;
          pantalla[x].yo=izquierda[x-23];
          pantalla[x].xf=27+30;
          pantalla[x].yf=izquierda[x-23]+54; 
          pantalla[x].colocacion=1;
          pantalla[x].defaultImage(1);
          pantalla[x].setNumero(numero);
          lista.addLast(pantalla[x]);
          numero++;
      }

      for( int x=0; x<7; x++){
          disponibles[x].xo= pos[x];
          disponibles[x].yo= 130+60-24;
          disponibles[x].xf= pos[x]+30;
          disponibles[x].yf= 130+60-24+54;
          disponibles[x].colocacion=1;
          disponibles[x].defaultImage(1);
          disponibles[x].key = 1;
      }
                         
 }

//FICHAS
public void	dibujarFichas(){}

public void info(){
	  for(int i=1; i<60; i++) System.out.println("");	
	  System.out.print("Teclee su nombre: ");
	  nombre = inputs.readStr();	  
}
public void protocolo(){
     try{   
        sock = new Socket("localhost",1442);
        in = new ObjectInputStream(sock.getInputStream());
        out = new ObjectOutputStream(sock.getOutputStream());    
     } catch(Exception e){
	  System.out.println("Error al conectar a servidor"+e);
     }

    try{
      System.out.println("Voy a leer la jugada inicial");
      inicial = (Inicial) in.readObject();
      System.out.println("Mis cartas son : ");
      for(int x=0; x<7; x++){
	   System.out.print(" "+inicial.cartas[x]);
      }            
      System.out.println("\nMi turno es el "+inicial.turno);
	System.out.println("Mi nombre es: "+nombre);
			
	out.writeUTF(nombre);
	out.flush();

	System.out.println("Voy a leer nombres de jugadores");

	nombres = (Inicial) in.readObject();
	
	for(int x=0; x<4; x++){
		System.out.println(nombres.name[x]);
	}
	setVisible(true);
	
	conectado=true;  	
	System.out.println("Voy a tratar de mostrar las siete cartas");
      vercartasdisponibles();

	System.out.println("pintar es igual a true");

	Domino4.pintar=true;
	repintar();

	System.out.println("Comenzando asignacin de turno");
	
	for(int x=0; x<inicial.turno; x++){
          recibemovimiento(x); turno_de++;
         if(x==0){
            actualizarPivote();                                 
	      repintar();
		crearNodosEspera();
		repintar();
         }
         else{
            repintar();
		actualizarPantalla();
		repintar();
         }
      }
      
      repintar();
      
	System.out.println("Voy a poner mi turno en verdadero"); 
      
      turno_de++;
      if(turno_de==4) turno_de=0;
      turnojuego=true;
      if(inicial.turno == 0){ primeravez=true;}
	else { modonormal = true; }
	
	repintar();
      
	for(;;){
		//do nothing
            System.out.println("ESTOY ESPERANDO MI MOVIMIENTO");
   		//try{ Thread.sleep(5000); }catch(Exception e){System.out.println("error thread");}
            if(!turnojuego){ break; }
	}     
      	                 
     	repintar();

	System.out.println("Ya sal de mi primer turno, ahora entrar al otro for");	
	
      boolean finjuego=false;
	for(;;){
  	  for(int x=0; x<3; x++){
		repintar();
		System.out.println("\nEscuchar una movida");
            ganador=turno_de;
            recibemovimiento(x);     turno_de++;
            if(turno_de==4) turno_de=0;
            repintar();
		actualizarPantalla(); 
		repintar();
            if(movida.gano){
                finjuego=true;
                end_of_game =true;
		    repintar();
                break;         
            }  
		repintar();
        }
        if(finjuego) { break; }
        else{
                turno_de++;
                if(turno_de==4) turno_de=0;
                turnojuego =true; repintar(); }
        for(;;){
	      System.out.println("ESTOY ESPERANDO MI MOVIEMIENTO");
		//try{ Thread.sleep(1000); }catch(Exception e){System.out.println("error thread");}
		if(!turnojuego){ break; }
        }     
        System.out.println("Ahora tengo "+numeropiezas+"  fichas en mi poder");
        repintar();
	}	
      end_of_game=true;
	repintar();

    }
    catch(Exception e){
       System.out.println("Fallo en funcion protocolo()  "+e);
	 System.exit(1);
    }
	  
}

 public void vercartasdisponibles(){
       for(int x=0; x<7; x++){
           disponibles[x].ficha=Ficha.getFicha(inicial.cartas[x],1);
       }
       resaltado = disponibles[0];
       piezanumero = 0;
       resaltado.key=1;    
	 repintar();  
	 System.out.println("Saliendo de vercartasdisponibles");
 }


 public void recibemovimiento(int x){
	   try{ movida= (Movida) in.readObject(); }
         catch(Exception e){ System.out.println(e); }
	   repintar();
 }

 public void actualizarPivote(){
        pivote.numero     =  movida.numero;
        pivote.key        =  movida.key;
        pivote.xo         =  movida.xo;
        pivote.yo         =  movida.yo;
        pivote.xf         =  movida.xf;
        pivote.yf         =  movida.yf;
        pivote.colocacion =  movida.colocacion;

        pivote.ficha = Ficha.getFicha(movida.clave,movida.posicion);
        pivote.ficha.pivote = movida.pivote;
        pivote.ficha.segundo = movida.segundo;

	  Nodo temp = new Nodo();
	  temp = lista.getElementAt(pivote.numero);
	  temp.ficha = pivote.ficha;
	  temp.key = pivote.key;
	  pivote = temp;
	  repintar();
 }


 public void moverNodoIzquierdo(int nuevovalorespera){
     izquierdo = izquierdo.getPrev();
     if(izquierdo.key == 9){
          izquierdo = lista.end.getPrev();
          if(izquierdo.key==1) {izquierdo.key=666;}
          else{
            izquierdo.valoresperado= nuevovalorespera;
            izquierdo.key=0;
          }
     }
     else if(izquierdo.key==1){ izquierdo.key=666;}
     else{
         izquierdo.valoresperado = nuevovalorespera;
         izquierdo.key=0;
     }
     repintar(); 
 }
 
 public void moverNodoDerecho(int nuevovalorespera){
     derecho = derecho.getNext();
     if(derecho.key == 9 ){
          derecho = lista.begin.getNext();
          if(derecho.key==1) {derecho.key=666;}
          else { derecho.valoresperado = nuevovalorespera;
                 derecho.key=0;
          }
      }
      else if( derecho.key==1) { derecho.key=666;}
      else{
          derecho.valoresperado = nuevovalorespera;
          derecho.key=0;
      }
	repintar(); 
 }

 public void crearNodosEspera(){
        izquierdo = pivote.getPrev(); derecho = pivote.getNext();
        if(izquierdo.key == 9) izquierdo = lista.end.getPrev();
        if(derecho.key == 9  ) derecho   = lista.begin.getNext();
        izquierdo.valoresperado = pivote.ficha.segundo;
        derecho.valoresperado = pivote.ficha.pivote;
	  repintar(); 
 }
 public void actualizarPantalla(){
   Nodo temp = new Nodo();
   if(movida.izquierdo){
        izquierdo.valoresperado = movida.valoresperado;
        izquierdo.numero        =  movida.numero;
        izquierdo.key           =  movida.key;
        izquierdo.xo            =  movida.xo;
        izquierdo.yo            =  movida.yo;
        izquierdo.xf            =  movida.xf;
        izquierdo.yf            =  movida.yf;
        izquierdo.colocacion    =  movida.colocacion;
        izquierdo.ficha = Ficha.getFicha(movida.clave,movida.posicion);
        izquierdo.ficha.pivote = movida.pivote;
        izquierdo.ficha.segundo = movida.segundo;
        moverNodoIzquierdo(izquierdo.valoresperado);
   }
   else if(movida.derecho){
        derecho.valoresperado   = movida.valoresperado;
        derecho.numero          =  movida.numero;
        derecho.key             =  movida.key;
        derecho.xo              =  movida.xo;
        derecho.yo              =  movida.yo;
        derecho.xf              =  movida.xf;
        derecho.yf              =  movida.yf;
        derecho.colocacion      =  movida.colocacion;
        derecho.ficha = Ficha.getFicha(movida.clave,movida.posicion);
        derecho.ficha.pivote = movida.pivote;
        derecho.ficha.segundo = movida.segundo;
        moverNodoDerecho(derecho.valoresperado);
   }
   repintar();
 }


public static void main(String args[]){
	 new Domino4("Proyecto Domino");
}

public void processMouseEvent(MouseEvent e){
	System.out.println("Eh.....");
}

public void  mouseClicked(MouseEvent e){
  if(e.getSource() == ok){
		System.exit(1);
  }
  if(e.getSource() == paso){
                avisarSaltoTurno();
                turnojuego=false;
		    repaint();
  }
  if(e.getSource() == chat){
 	 try{
		String enviado="";
		enviado=nombre+":   ";
		enviado= enviado+ individual.getText();
		chatd.out.writeUTF(enviado);
		chatd.out.flush();
		individual.setText("");

	}catch(Exception ee){System.out.println("error al enviar chat message");}
  }

  if( dibujo.contains( e.getX(),e.getY()) ){
	System.out.println("click");
	observarPantalla(e.getX(),e.getY());
  }

}


 public void avisarSaltoTurno(){
        Movida enviar = new Movida(inicial.turno);
        try{
            out.writeObject(enviar);
            out.flush();
        }
        catch(Exception e){}
	  repaint();                       
 }


//Observar las jugadas

public void repintar(){
	dibujo.repaint();
}

public void observarPantalla(int a,int b){
		x1=a; y1=b;
		//System.out.println("Click en juego: ( "+x+","+y+")");
		//dibujo.repintar();
   
    	  if( clickpermitido(x1,y1)  && primeravez ){
   	 	 observarpivoteinicial();
		 System.out.println("Voy a observar primera jugada...");
    	  }

    	  if(resaltado.key != 666 && !end_of_game && turnojuego){
    	       if(modonormal){
	     		vigilarizquierdo();
           		vigilarderecho();
           		
             } 
             if(coord(x1,y1,105,130+60-24,495,130+60-24+54)){
			System.out.println("Voy a observar ficha...");
	     		vigilarDisponible();        
             }        } 

}

 public void vigilarizquierdo(){
	if(coord(x1,y1,izquierdo.xo,izquierdo.yo,izquierdo.xf,izquierdo.yf)  && izquierdo.key!=666){
             System.out.println("Dieron click en el nodo izquierdo");
             int nuevovalorespera;
             boolean ok=false;
             if(resaltado.ficha.pivote == izquierdo.valoresperado){
                 ok=true;
                 izquierdo.key=1;
                 izquierdo.ficha = Ficha.getFicha(resaltado.ficha.clave,izquierdo.colocacion);
                 izquierdo.valoresperado = resaltado.ficha.segundo;
                 nuevovalorespera= resaltado.ficha.segundo;
             }
             else if( resaltado.ficha.segundo == izquierdo.valoresperado){
                 ok=true;
                 izquierdo.key=1;
                 int colocacion;
                 if( (izquierdo.colocacion == 3) || (izquierdo.colocacion==1)){
                     colocacion= izquierdo.colocacion +1;
                 }
                 else{
                     colocacion= izquierdo.colocacion -1;
                 }
                 izquierdo.ficha = Ficha.getFicha(resaltado.ficha.clave,colocacion);
                 izquierdo.valoresperado = resaltado.ficha.pivote;//para que al mandarlos sepan cual es el siguiente a esperar
                 nuevovalorespera= resaltado.ficha.pivote;
             }
             else { nuevovalorespera=0;}

             if(ok){
                numeropiezas = numeropiezas-1;
		    izquierdo.izquierdo=true;
                notificarServidor(izquierdo);
                moverNodoIzquierdo(nuevovalorespera);
                resaltado.defaultImage(1);
                siguientedisponible();
                turnojuego=false;
                repintar();
		 }
         repintar();
	   } 
 }



 public void vigilarderecho(){
	if(coord(x1,y1,derecho.xo,derecho.yo,derecho.xf,derecho.yf)  && derecho.key!=666){
             System.out.println("Dieron click en el nodo derecho");
             int nuevovalorespera;
             boolean ok=false;
             if(resaltado.ficha.pivote == derecho.valoresperado){
                ok=true;
                derecho.key=1;
                int colocacion;
                if( (derecho.colocacion == 3) || (derecho.colocacion==1)){
                    colocacion= derecho.colocacion +1;
                }
                else{
                    colocacion= derecho.colocacion -1;
                }
               derecho.ficha = Ficha.getFicha(resaltado.ficha.clave,colocacion);
               derecho.valoresperado = resaltado.ficha.segundo;
		   nuevovalorespera = resaltado.ficha.segundo;
             }
             else if( resaltado.ficha.segundo == derecho.valoresperado){
                ok=true;
                derecho.key=1;
                derecho.ficha = Ficha.getFicha(resaltado.ficha.clave,derecho.colocacion);
                derecho.valoresperado = resaltado.ficha.pivote;
		    nuevovalorespera = resaltado.ficha.pivote;
             }
             else { nuevovalorespera =0; }
        
             if(ok){
                numeropiezas = numeropiezas-1;
		    derecho.derecho = true;
                notificarServidor(derecho);
                moverNodoDerecho(nuevovalorespera);
                resaltado.defaultImage(1);
                siguientedisponible();
                turnojuego=false;
                repintar(); 
		}
	   repintar();
	   } 
 }
 
 public boolean clickpermitido( int x1, int y1){
    if( coord(x1,y1,57,35,543,65) ||
        coord(x1,y1,27,35,57,305) ||
        coord(x1,y1,543,35,573,305) ||
        coord(x1,y1,57,275,543,305) ){
        return true;
    }
    else return false;
 }
 public  void siguientedisponible(){
        int i,oportunidades=0;
        resaltado.key=666;
        piezanumero = piezanumero +1;
        if(piezanumero ==7) piezanumero=0;
        i = piezanumero;
        
        for(oportunidades=0; oportunidades<10; oportunidades++){
                if(disponibles[i].key != 666){
                        resaltado = disponibles[i];
                        resaltado.key=0;
                        piezanumero = i;
                        break;             
                }
                i++;
                if(i==7) i=0;
        }
        repintar();
 }



 public boolean coord(int x, int y, int xo, int yo, int xf , int yf){
       if( x>=xo && x<=xf && y>=yo && y<=yf ) return true;
       else return false;
 }

 public void notificarServidor(Nodo temp){

        Movida enviar        = new Movida(inicial.turno);
        enviar.numero        = temp.getNumero();
        enviar.key           = temp.key;
        enviar.xo            = temp.xo;
        enviar.yo            = temp.yo;
        enviar.xf            = temp.xf;
        enviar.yf            = temp.yf;
        enviar.valoresperado = temp.valoresperado;
        enviar.colocacion    = temp.colocacion;

        enviar.clave         = temp.ficha.clave;
        enviar.posicion      = temp.ficha.posicion;
        enviar.pivote       = temp.ficha.pivote;
        enviar.segundo       = temp.ficha.segundo;
        enviar.derecho       = temp.derecho;
        enviar.izquierdo     = temp.izquierdo;
	 
        if(numeropiezas == 0){ enviar.gano=true; }
	  else { enviar.gano =  false; }

        try{
           out.writeObject(enviar);
           out.flush();
        } catch(Exception e){ System.out.println(" NETWORK ERROR !");}
          if(numeropiezas ==0){ 
			end_of_game = true;
	    		tu_ganaste=true;
	    }
				   
	  repintar();
 }

 public void vigilarDisponible(){
	 for(int x=0; x<7; x++){
               Nodo s = new Nodo(); s = disponibles[x];
               if( coord(x1,y1,s.xo,s.yo,s.xf,s.yf) && disponibles[x].key != 666 ){
                 System.out.println("SOY UNA FICHA"+"\n*********************//");
                 System.out.println("Mi pivote es: "+disponibles[x].ficha.pivote);
                 System.out.println("Mi segundo es: "+disponibles[x].ficha.segundo);
                 System.out.println("\n\n");
                 resaltado=disponibles[x];
                 piezanumero = x;
                 repintar();
		     break;
               }
      }
 }


 public void observarpivoteinicial(){
       for(int x=1; x<=28; x++){
          Nodo p = lista.getElementAt(x);
          if(coord(x1,y1,p.xo,p.yo,p.xf,p.yf)){
               primeravez=false;
               numeropiezas = numeropiezas -1;
               p.ficha = Ficha.getFicha(resaltado.ficha.clave,p.colocacion);
               p.key=1;
               disponibles[piezanumero].key=666;
               disponibles[piezanumero].defaultImage(1);
               piezanumero= piezanumero+1;
               if(piezanumero==7) piezanumero=0;
               pivote = p;
               resaltado= disponibles[piezanumero];
               crearNodosEspera();
               notificarServidor(pivote);
               turnojuego=false;
               modonormal=true; 
               repintar();
		   break;
          }
       }
 
 }  
 

public void mouseEntered(MouseEvent  e){}
public void  mouseExited(MouseEvent e){} 
public void  mousePressed(MouseEvent e){}
public void  mouseReleased(MouseEvent e){} 


public void windowActivated(WindowEvent e){}
public void windowClosed(WindowEvent e){}
public void  windowClosing(WindowEvent e){ System.exit(1); }
public void  windowDeactivated(WindowEvent e){}
public void  windowDeiconified(WindowEvent e){}
public void  windowIconified(WindowEvent e){}
public void  windowOpened(WindowEvent e){}


}

class P extends Panel{
	int maxx,maxy;
	
	Domino4 c;

	public P(Domino4 e){
		c=e;
	}

	public void paint(Graphics g){
		if(Domino4.pintar){
			//g.setColor(Color.black);
			//g.fillRect(0,0,getBounds().width,getBounds().height);	
			//g.setColor(Domino4.color);
			//g.setFont( new Font("Lucida Handwriting",Font.BOLD, 24));
			//g.drawString("Domino",50,20);


        		g.setColor(new Color(   (float)0.4  ,(float).8599 ,(float) 0.3));
        		g.fillRect(0,0,600,450);
        		g.drawLine(5,350,595,350);
       
		        //Dibujar rectangulos en pantalla con Nodos
		        g.setColor(Color.black);
		        for(int x=1; x<=28; x++){
		           Nodo ee= c.lista.getElementAt(x);
		           g.drawRect(ee.xo,ee.yo,ee.xf-ee.xo,ee.yf-ee.yo);
		        }    
			 //Escribir ttulo
		        g.setColor(Color.red);
		        g.setFont(new Font("Comic Sans",Font.BOLD, 16));
		        g.drawString("Fichas a elegir:",105,39+100+13);
		        g.setFont(new Font("Comic Sans",Font.BOLD, 14));
		        g.setColor(Color.black); 
		        g.drawString("Ventana de "+c.nombre,390 ,39+100+13 );
	
	       	  g.setFont(new Font("Comic Sans",Font.BOLD, 15));
			  g.setColor(new Color(  (float).35979 ,(float).4839 ,(float)  .57993 ) );
 			  g.setColor(Color.blue);  	  

	       	  g.setFont(new Font("Comic Sans",Font.BOLD, 14));
          		  g.drawString("Status juego:",27,348-20);

		        //Escribir turno
		        if(c.turnojuego){
		          g.drawString("Le toca mover", 27+50+19+35, 348-20);
		        }
		        else{
		         if(c.end_of_game){
		      	   if(c.tu_ganaste){
						 g.drawString("Felicidades, ganaste",27+50+19+35,348-20);

				  } else{
						 g.drawString("El ganador "+c.nombres.name[c.ganador]+" , fin del juego",27+50+19+35,348-20);
      		  		}
	   		 }
          		else{
          		 g.drawString("Esperando a "+c.nombres.name[c.turno_de]+"...",27+50+19+35,348-20);
         		 }
	    	}

        //Poner las imagenes de cada Nodo en su rectangulo correspondiente
        for(int x=1; x<=28; x++){
                Nodo temp= c.lista.getElementAt(x);
                g.drawImage(temp.ficha.image,temp.xo,temp.yo,this);
                //try{ Thread.sleep(1000); }catch(Exception e){}
        }     

        //Dibuja las imagenes de los 7 Nodos de las cartas
        g.setColor(Color.red);
        for(int x=0; x<7; x++){
           g.drawImage(c.disponibles[x].ficha.image,c.disponibles[x].xo,c.disponibles[x].yo,this);
           if(c.resaltado == c.disponibles[x] && c.numeropiezas!=0){
                Nodo s = new Nodo(); s=c.disponibles[x];
                g.drawRect(s.xo-4,s.yo-4,s.xf-s.xo+8,s.yf-s.yo+8);
           }
        }

	}

}


public void update(Graphics g){
        paint(g);
} 
	
}


class ThreadChat extends Thread{

 String recibido;
 Domino4 c;        //instancia del cliente

 Socket socket;
 ObjectOutput out;
 ObjectInput in;


 public ThreadChat(Domino4 ee){
    c=ee;	
    start();
    
  }
 
 public void run(){
  try{

	System.out.println("Tratando de conectar a un Chat Server..");
        socket = new Socket("localhost",1443);
	out = new ObjectOutputStream( socket.getOutputStream());
	in  = new ObjectInputStream( socket.getInputStream());	
  }catch(Exception e){ System.out.println("Error al iniciar chat");}
  
  try{
	for(;;){
		recibido = (String) in.readUTF();
		c.conjunto.append("\n"+recibido);
	}
  }
  catch(Exception e){ System.out.println("Error durante el chat");}

 }

}



class Titulo extends Panel{

public Titulo(){}

public void paint(Graphics g){
	
	         	  g.setColor(new Color(  (float)0.299, (float).1299 ,(float).3499 ));
			  g.fillRect(0,0,400,400);
			  
		        g.setColor(Color.white);
		        g.setFont(new Font("Comic Sans",Font.PLAIN, 18));
		        g.drawString("Chat",10+88,15);
}
public void update(Graphics g){
        paint(g);
} 
	
}

