/*
Author: Cristhian Alcntara Cadillo
Version: Domino 5.5.5 (Domino 2) May 2000
e-mail: tungra@hotmail.com
icq-number:   51821309
icq-username: tungra
Compiler: JDK 1.1.7
Proved with Windows 98,95,Millenium Edition
All rights reserved
*/


public class Lista extends Nodo{

 private int n;
 Nodo begin;
 Nodo end;

 public Lista(){
     n=0;
     begin= new Nodo(9);
     end = new Nodo(9);
     begin.setPrev(end);
     begin.setNext(end);
     end.setPrev(begin);
     end.setNext(begin);
 }

 public Nodo getFirst(){
	return begin.getNext();
 }

 public Nodo getLast(){
      return end.getPrev();
 }

 public void addLast( Nodo e){
      n++;
	e.setPrev( end.getPrev());
	e.setNext(end);
	end.getPrev().setNext(e);
      end.setPrev(e);
 }

 public void addFirst( Nodo e){
	n++;
	e.setNext( begin.getNext());
	e.setPrev( begin);
	begin.getNext().setPrev(e);
	begin.setNext(e);
 }

 public void addElementAt(int x,Nodo e){
	n++;
	Nodo temp=begin.getNext();
      for(int y=1;y<x;y++){
	   temp=temp.getNext();
	}
	e.setPrev(temp.getPrev());
	e.setNext(temp);
	temp.getPrev().setNext(e);
	temp.setPrev(e);
 }

 public void deleteLastElement(){
 	n--;
	end.getPrev().getPrev().setNext(end);
	end.setPrev(end.getPrev().getPrev());
 }

 public void deleteElementAt(int x){
     if(x==n) deleteLastElement();
     else{
	   n--;
	   Nodo temp;
	   temp= begin.getNext();
	   for(int y=1;y<x;y++){
	        temp=temp.getNext();
	   }	
		
	   Nodo temp1= temp.getPrev();    
	   Nodo temp2= temp.getNext();
	   temp1.setNext(temp2);
	   temp2.setPrev(temp1);   
	}
 }
 
 public Nodo getElementAt(int x){
	 
		Nodo temp;
		if(x==1){ temp=begin.getNext();}
		if(x==n){ temp=end.getPrev();}
		else{
		     temp=begin.getNext();
		     for(int y=1;y<x;y++){
		         temp=temp.getNext();	
		     }
				
		}  
                return temp;
 }


 public int getSize(){
	return n;
 }


}
