/*
Author: Cristhian Alcntara Cadillo
Version: Domino 5.5.5 (Domino 2) May 2000
e-mail: tungra@hotmail.com
icq-number:   51821309
icq-username: tungra
Compiler: JDK 1.1.7
Proved with Windows 98,95,Millenium Edition
All rights reserved
*/


import java.awt.*;
import java.io.*;
import java.net.*;
import java.util.*;

public class Ficha implements Serializable{

  Image image;
  Toolkit tool;
  String name;
  int clave;
  int posicion;
  int arriba;
  int abajo;
  int derecha;
  int izquierda;
  int pivote;
  int segundo;


 public Ficha(){}

 public static Ficha getFicha(int clave, int pos){

    Ficha ficha = new Ficha();
    ficha.tool= Toolkit.getDefaultToolkit();
    ficha.posicion=pos;
    ficha.clave= clave;

    int where=1;
    int segundo = ficha.getSegundo(clave);
    int pivote = ficha.getpivote(clave,segundo);
    ficha.pivote = pivote;
    ficha.segundo = segundo;

    if(pos==1){  ficha.arriba=pivote; ficha.abajo=segundo;where=1;}
    else if (pos==2){ ficha.arriba=segundo; ficha.abajo = pivote; where=2;}
    else if (pos==3){ ficha.derecha=pivote; ficha.izquierda=segundo; where=3;}
    else if (pos==4){ ficha.derecha=segundo; ficha.izquierda=pivote; where=4;}

    ficha.name = "ficha"+clave+"_"+where+".jpg";
    ficha.image = ficha.tool.getImage("ficha"+clave+"_"+where+".jpg");

    return ficha;
 }


 public int getSegundo(int clave){
    if(clave==0) return 0;
    else if(clave >=1  && clave<= 2  )   {return 1;}
    else if(clave >=3  && clave<= 5  )   {return 2;}
    else if(clave >=6  && clave<= 9  )   {return 3;}
    else if(clave >=10 && clave<= 14 )   {return 4;}
    else if(clave >=15 && clave<= 20 )   {return 5;}
    else if(clave >=21 && clave<= 27 )   {return 6;}
    else return 9999;
 }

 public int getpivote(int clave, int segundo){

    switch(segundo){
        case 0:  return 0        ;  
        case 1:  return clave-1  ;  
        case 2:  return clave-3  ;  
        case 3:  return clave-6  ;  
        case 4:  return clave-10 ;  
        case 5:  return clave-15 ;  
        case 6:  return clave-21 ;  
        default: return 999;
    }

 }

 public static void main(String args[]){

        int clave=17;
        int posicion=1;
        Ficha ficha;
        ficha = Ficha.getFicha(clave,posicion);


        System.out.println("Mande la clave: "+clave+" y posicin: "+posicion+" y obtuve:");
        System.out.println("Parte de arriba= "+ficha.arriba);
        System.out.println("Parte de abajo = "+ficha.abajo);
        System.out.println("El path de la imagen es: "+ficha.name);

 }
}
