/*
Author: Cristhian Alcntara Cadillo
Version: Domino 5.5.5 (Domino 2) May 2000
e-mail: tungra@hotmail.com
icq-number:   51821309
icq-username: tungra
Compiler: JDK 1.1.7
Proved with Windows 98,95,Millenium Edition
All rights reserved
*/


import java.awt.*;
import java.io.*;
import java.net.*;
import java.util.*;


public class Nodo implements Serializable{

  boolean izquierdo=false;
  boolean derecho=false;
  int numero;
  int key;           //1 ocupado, 0 no ocupado, 9 nodo dummy
  int xo;
  int yo;
  int xf;
  int yf;
  int valoresperado;
  int colocacion;    //1 vertical, 3 horizontal
  Ficha ficha;
  Toolkit tool;

  private Nodo next;
  private Nodo prev;
	
     

  public Nodo(){
        key=0;
        next=null;
        prev=null;
        tool = Toolkit.getDefaultToolkit();
        ficha = new Ficha();
        
  }

  public Nodo(int x){
        key=x;
        next=null;
        prev=null;
        tool = Toolkit.getDefaultToolkit();
        ficha = new Ficha();
  }


  public void defaultImage(int x){
        if(x==1){
            ficha.image = tool.getImage("verde.jpg");    
            ficha.name = "verde.jpg";
            ficha.posicion=1;
        }
        else if( x==3){
            ficha.image = tool.getImage("verde_1.jpg");
            ficha.name = "verde.jgp";
            ficha.posicion=3;
        }
        else if( x==123){
            ficha.image = tool.getImage("boton.jpg");
            ficha.name = "boton.jpg";
            ficha.posicion=1;
        }
  }



  public Nodo getNext(){ return next; }
  public Nodo getPrev(){ return prev; }
  public void setNext(Nodo n){next=n;}
  public void setPrev(Nodo p){prev=p;}
  public void setNumero( int x){ numero = x; }
  public int  getNumero(){ return numero; }
       
}
